#pragma once
#include "afxwin.h"
#include ".\DPPDLG\Controls\PlotCanvas.h"
#include ".\DPPDLG\Controls\ColorCtrl.h"		// adds color functions to controls
#include ".\DPPDLG\Controls\FontCtrl.h"
#include ".\DPPDLG\Controls\trapkeyedit.h"		// adds advanced editing functions to text controls
#include ".\DPPDLG\GainPZ\dppinputoffset.h"		// input offset control class
#include ".\DPPDLG\Misc\dppdac.h"
#include ".\DPPDLG\Misc\dpppx4aux.h"

// CPlotCanvasDlg dialog

class CPlotCanvasDlg : public CDialog
{
	DECLARE_DYNAMIC(CPlotCanvasDlg)

public:
	CPlotCanvasDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CPlotCanvasDlg();

// Dialog Data
	enum { IDD = IDD_PlotCanvas };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	//CStatic m_PlotCanvasCtrl;
	CPlotCanvas m_PlotCanvasCtrl;
	void DoDisplayScopeDlg(void);
	BOOL m_active;
	BOOL isInit;
	UINT m_nMonitorElapsedTime;
	UINT m_nMonitorTimerId;
	UINT m_nMonitorEventId;	

	afx_msg void OnDestroy();
	bool PaintDone;

protected:
	virtual void OnOK();
	virtual void OnCancel();

public:
	afx_msg void OnTimer(UINT nIDEvent);
	void UpdateMonitors();
	void UpdateScopeTimebaseCombo();

	CButton m_ArmTriggerButton;
	//bool m_ArmTriggerBool;
	CButton m_AutoReArmCheck;
	int m_AutoReArmInt;
	CButton m_PersistenceCheck;
	int m_PersistenceInt;
	CColorCtrl<CComboBox> m_ScopeTimebaseCombo;
	//int m_ScopeTimebaseInt;
	//CComboBox m_ScopeTriggerPositionCombo;
	int m_ScopeTriggerPositionInt;
	//CComboBox m_ScopeTriggerSlopeCombo;
	int m_ScopeTriggerSlopeInt;
	afx_msg void OnBnClickedAutorearmcheck();
	afx_msg void OnBnClickedArmtriggerbutton();
	afx_msg void OnBnClickedPersistencecheck();
	afx_msg void OnCbnSelchangeScopetimebasecombo();
	afx_msg void OnCbnSelchangeScopetriggerpositioncombo();
	afx_msg void OnCbnSelchangeScopetriggerslopecombo();
	afx_msg void OnBnClickedOk();
	afx_msg void OnPaint();
	afx_msg void OnClose();
	//void GetColor(int CtrlID, COLORREF &target);
	afx_msg void OnBnClickedCleartracebutton();
	afx_msg void OnBnClickedMinimizebutton();
	afx_msg void OnBnClickedClosewinbutton();

// Attributes for scope frame bitmap
protected:
   CRect LastRect;

public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnBnClickedSizewinbutton();				
	afx_msg void OnBnClickedSizewinbutton2();
	afx_msg void OnBnClickedSizewinbutton3();				// minimize window		
	afx_msg void OnBnClickedRefreshusbbutton();				
	void OnWindowCapture(); 
	afx_msg void OnBnClickedCapturetracebutton();			// large button
	afx_msg void OnBnClickedCapturetracebutton2();			// small button on scope display

	// dialog control setup functions
	void InitControls();
	void InitControlValues();
	void EnableDppControls();
	void UpdateConfigValues();
	double GetOffsetDisplayValFromCtrl(CString cstrOffset); 


	// ---------------------------------------------------------------------
	// input offset controls------------------------------------------------
	CDppInputOffset InputOffset;
	CTrapKeyEdit m_InputOffsetEdit;
	CSpinButtonCtrl m_InputOffsetSpin;
	afx_msg void OnEnChangeInputoffsetedit();
	afx_msg void OnDeltaposInputoffsetspin(NMHDR *pNMHDR, LRESULT *pResult);
	// ---------------------------------------------------------------------

	// ---------------------------------------------------------------------
	// aux output controls--------------------------------------------------
	CDppPX4Aux PX4Aux;
	CComboBox m_PX4AuxCombo;
	afx_msg void OnCbnSelchangePx4auxcombo();
	// ---------------------------------------------------------------------

	// ---------------------------------------------------------------------
	// analog out (DAC) controls--------------------------------------------
	CDppDAC DAC;
	//int m_DACint;
	CComboBox m_DACCombo;
	afx_msg void OnCbnSelchangeDaccombo();
	// ---------------------------------------------------------------------

	// ---------------------------------------------------------------------
	// output offset controls uses CDppDAC DAC support class----------------
	//CString m_OffsetCStr;
	CTrapKeyEdit m_OffsetEditCtrl;
	CSpinButtonCtrl m_OffsetSpinCtrl;
	CString GetOutputOffsetStrFromVal(long OffsetVal);
	afx_msg void OnEnChangeOffsetedit();
	afx_msg void OnDeltaposOffsetspin(NMHDR *pNMHDR, LRESULT *pResult);
	// ---------------------------------------------------------------------

	//CButton m_DialogMinimizeButton;
	CFontCtrlEx<CButton, FC_FONT_BOLD, 16> m_DialogMinimizeButton;
	//CButton m_DialogCloseWinButton;
	CFontCtrlEx<CButton, FC_FONT_BOLD, 14> m_DialogCloseWinButton;
};
